package org.bitbucket.bradleysmithllc.etlunit.feature;

import org.bitbucket.bradleysmithllc.etlunit.BaseFeatureLocator;
import org.bitbucket.bradleysmithllc.etlunit.util.NeedsTest;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ServiceLoader;

@NeedsTest
public class ServiceLocatorFeatureLocator extends BaseFeatureLocator
{
	private final ClassLoader loader;

	public ServiceLocatorFeatureLocator()
	{
		this(null);
	}

	public ServiceLocatorFeatureLocator(ClassLoader loader)
	{
		this.loader = loader;
	}

	@Override
	public List<Feature> getFeatures()
	{
		List<Feature> features = new ArrayList<Feature>();

		ClassLoader cl = loader == null ? Thread.currentThread().getContextClassLoader() : loader;

		ServiceLoader<Feature> sl = ServiceLoader.load(Feature.class, cl);

		Iterator<Feature> it = sl.iterator();

		while (it.hasNext())
		{
			features.add(it.next());
		}

		return features;
	}
}