package org.bitbucket.bradleysmithllc.etlunit.feature.logging;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;

import java.io.File;
import java.io.IOException;
import java.util.List;

public interface LogFileManager
{
	interface LogFile
	{
		String getMessage();

		String getClassifier();

		File getFile();

		File getOriginalPath();

		ETLTestOperation getTestOperation();

		ETLTestMethod getTestMethod();

		ETLTestClass getTestClass();
	}

	List<LogFile> getLogFilesByETLTestOperation(ETLTestOperation operation);

	List<LogFile> getLogFilesByETLTestMethod(ETLTestMethod operation);

	List<LogFile> getLogFilesByETLTestClass(ETLTestClass operation);

	void addLogFile(ETLTestMethod method, ETLTestOperation operation, File log, String classifier) throws IOException;
	void addLogFile(ETLTestOperation operation, File log, String classifier) throws IOException;

	void addLogFile(ETLTestMethod operation, File log, String classifier) throws IOException;

	void addLogFile(ETLTestClass operation, File log, String classifier) throws IOException;

	void addLogFile(File log, String classifier) throws IOException;

	void addLogFile(ETLTestMethod method, ETLTestOperation operation, File log, String classifier, String message) throws IOException;
	void addLogFile(ETLTestOperation operation, File log, String classifier, String message) throws IOException;

	void addLogFile(ETLTestMethod operation, File log, String classifier, String message) throws IOException;

	void addLogFile(ETLTestClass operation, File log, String classifier, String message) throws IOException;

	void addLogFile(File log, String classifier, String message) throws IOException;

	File getLogRoot();
}